
SimpleObjectivesMinimapButton = CreateFrame("Button",nil,UIParent)
SimpleObjectivesMinimapButton:SetMovable(true)
SimpleObjectivesMinimapButton:SetSize(32,32)
SimpleObjectivesMinimapButton:RegisterForClicks("LeftButtonUp")
SimpleObjectivesMinimapButton:RegisterForDrag("RightButton")


SimpleObjectivesMinimapButton:SetScript("OnEvent",function(self, event, ...) self[event](self, ...) end)

SimpleObjectivesMinimapButton:RegisterEvent("ADDON_LOADED")

SimpleObjectivesMinimapButton:RegisterEvent("SCENARIO_CRITERIA_UPDATE")

SimpleObjectivesMinimapButton_Icon = SimpleObjectivesMinimapButton:CreateTexture()
SimpleObjectivesMinimapButton_Icon:SetTexture("Interface\\WorldMap\\UI-WorldMap-QuestIcon")
SimpleObjectivesMinimapButton_Icon:SetAllPoints();


SLASH_SOH1, SLASH_SOH2 = "/simpleobjectivehider", "/soh"

DEFAULT_TEX_COORDS = { 0, 0, 0, 0.5, 0.5, 0, 0.5, 0.5 }
CLICK_TEX_COORDS = { 0.5, 0, 0.5, 0.5, 1.0, 0, 1.0, 0.5 }

MouseOverride = false
ObjectiveVisibility = true
ObjectiveWQ = ""

sohaddonLoaded = false
nCrit = 0


function SimpleObjectivesMinimapButton_OnDragStart()
	SimpleObjectivesMinimapButton:LockHighlight()
	SimpleObjectivesMinimapButton:StartMoving()
end
function SimpleObjectivesMinimapButton_OnDragStop()
	SimpleObjectivesMinimapButton:UnlockHighlight()
	SimpleObjectivesMinimapButton:StopMovingOrSizing()
	if (sohaddonLoaded == true) then
		MapPosPTemp = {SimpleObjectivesMinimapButton:GetPoint()}
		MapPosP = {MapPosPTemp[1],MapPosPTemp[3],MapPosPTemp[4],MapPosPTemp[5]}
		
		SOHDatsSL = {  MapPosP = MapPosP, ObjectiveVisible = ObjectiveVisibility, MapIcon = MapIcon }
	end
end


function SimpleObjectivesMinimapButton:ADDON_LOADED(arg1, ...)

	if (arg1 == "SimpleObjectives") then

		if SOHDatsSL == nil or SOHDatsSL.MapPosP == nil or SOHDatsSL.ObjectiveVisible == nil or SOHDatsSL.MapIcon == nil then
			MapPosP = {"TOPRIGHT", "TOPRIGHT", 0,0}
			SOHDatsSL = { MapPosP = MapPosP , ObjectiveVisible = true, MapIcon = true }
		end
		MapPosP = SOHDatsSL.MapPosP
		MapIcon = SOHDatsSL.MapIcon
		ObjectiveVisibility = SOHDatsSL.ObjectiveVisible
		ToggleObjectives(true)
		SetDefaultTexture()

		SimpleObjectivesMinimapButton:SetPoint(MapPosP[1],UIParent,MapPosP[3],MapPosP[4],MapPosP[5])

		sohaddonLoaded = true
		ToggleMapIcon(true)
		SlashCmdList["SOH"] = SOHSlashHandler
	end

end
function SimpleObjectivesMinimapButton:SCENARIO_CRITERIA_UPDATE()
	local sType = select(10, C_Scenario.GetInfo())
	if sType == LE_SCENARIO_TYPE_CHALLENGE_MODE then
		local nCrita = select(3, C_Scenario.GetStepInfo())
		for cInd = 1, nCrita do
			local _, _, _, quantity, totalQuantity, _, _, _, _, _, _, _, weighted = C_Scenario.GetCriteriaInfo(cInd)
			if (weighted) then
				nCrit = quantity .. "%"
			end
		end
	end
end
function SOHSlashHandler(msg, ...)
	local ret = ""


	if (msg =="toggle") then
		PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
		ToggleObjectives(false)
		ret = "yes"
	end

	if (msg =="map" or msg == "icon") then
		PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
		ToggleMapIcon(false)
		ret = "yes"
	end
	if (msg == "menu") then
		_G['SimplerObjectives']:Show();
		ret = "yes"
	end

	if (ret == "") then
		DEFAULT_CHAT_FRAME:AddMessage("Simple Objectives Hider\n-----------\n|cfff0ff00/soh map |cffffffffor|cfff0ff00 /soh icon - |cfffffffftoggles map icon\n|cff0f0ff0/soh toggle - |cfffffffftoggle objectives frame\n|cffafaff0/soh menu - |cffffffffopen simple objectives hider menu")
	end
end

function ToggleMapIcon(init)		
	if (init == true) then
		if (MapIcon == true) then
			SimpleObjectivesMinimapButton:Show();
		else
			SimpleObjectivesMinimapButton:Hide();
		end
	else

		if (SimpleObjectivesMinimapButton:IsVisible()) then
			SOHDatsSL.MapIcon = false;
			SimpleObjectivesMinimapButton:Hide();
		else
			SOHDatsSL.MapIcon = true;
			SimpleObjectivesMinimapButton:Show();
		end
	end

end


function ToggleObjectives(startup)
	local objectFrame = ObjectiveTrackerFrame:IsShown()
	if startup == true then
		objectFrame = not ObjectiveVisibility
	end
	local chatMessage = ""
	
	if objectFrame then 
		chatMessage = "Objective Window: |cfff000f0Hidden"
		ObjectiveTrackerFrame:Hide() 
	else 
		chatMessage = "Objective Window: |cff00ff00Visible"
		ObjectiveTrackerFrame:Show() 
	end
	ObjectiveVisibility = ObjectiveTrackerFrame:IsShown()
	SOHDatsSL.ObjectiveVisible = ObjectiveVisibility
	return chatMessage
end
function SimpleObjectivesMinimapButton_OnClick()
	PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
	RaidNotice_AddMessage(RaidWarningFrame, ToggleObjectives(false), ChatTypeInfo["RAID_WARNING"])
end
function SimpleObjectivesMinimapButton_OnMouseDown()
	MouseOverride = true;
	SetClickTexture()
end
function SimpleObjectivesMinimapButton_OnMouseUp()
	MouseOverride = false;
	SetDefaultTexture()
end
function SimpleObjectivesMinimapButton_OnLeave()
	MouseOverride = false;
	SetDefaultTexture()
	GameTooltip:Hide()
end

function SimpleObjectivesMinimapButton_OnEnter()
	SetClickTexture()
	GameTooltip:SetOwner(SimpleObjectivesMinimapButton_Icon, "ANCHOR_BOTTOMLEFT",0, 30)
	GameTooltip:SetText("|cffffffffSimple Objectives Hider")
	GameTooltip:AddLine("|cff666666Left Click - |cff00ff00Toggle Objectives")
	GameTooltip:AddLine("|cff666666Right Click - |cff00ff00Move This")

	local inst, instType = IsInInstance()
	if (not ObjectiveTrackerFrame:IsShown()) then
		if (inst and (instType == "party" or instType == nil)) then
			GameTooltip:AddLine("\n\r|cffffffffDungeon Objectives : ")
			for k,v in pairs(ScenarioObjectiveBlock.lines) do
				
				if (strfind("Enemy Forces", v.Text:GetText())) then
					GameTooltip:AddLine(nCrit)
				else
					GameTooltip:AddLine(v.Text:GetText())
				end
				
			end
		end
		
		GameTooltip:AddLine(ObjectiveWQ)
	end


	GameTooltip:Show()
end

function SetDefaultTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(DEFAULT_TEX_COORDS[1],DEFAULT_TEX_COORDS[2],DEFAULT_TEX_COORDS[3],DEFAULT_TEX_COORDS[4],DEFAULT_TEX_COORDS[5],DEFAULT_TEX_COORDS[6],DEFAULT_TEX_COORDS[7],DEFAULT_TEX_COORDS[8])
end

function SetClickTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(CLICK_TEX_COORDS[1],CLICK_TEX_COORDS[2],CLICK_TEX_COORDS[3],CLICK_TEX_COORDS[4],CLICK_TEX_COORDS[5],CLICK_TEX_COORDS[6],CLICK_TEX_COORDS[7],CLICK_TEX_COORDS[8])
end






local FIX = CreateFrame("Frame");


SimpleObjectivesMinimapButton:SetScript("OnMouseDown",SimpleObjectivesMinimapButton_OnMouseDown)
SimpleObjectivesMinimapButton:SetScript("OnMouseUp",SimpleObjectivesMinimapButton_OnMouseUp)
SimpleObjectivesMinimapButton:SetScript("OnLeave",SimpleObjectivesMinimapButton_OnLeave)
SimpleObjectivesMinimapButton:SetScript("OnEnter",SimpleObjectivesMinimapButton_OnEnter)
SimpleObjectivesMinimapButton:SetScript("OnClick",SimpleObjectivesMinimapButton_OnClick)
SimpleObjectivesMinimapButton:SetScript("OnDragStart",SimpleObjectivesMinimapButton_OnDragStart)
SimpleObjectivesMinimapButton:SetScript("OnDragStop",SimpleObjectivesMinimapButton_OnDragStop)
